## rest-api-client.sh

List of all functions in alphabetic order

### http()

[line: 95](https://git-repo.iml.unibe.ch/iml-open-source/bash-rest-api-client/-/blob/master/rest-api-client.sh#L95)

### http.addHeader()

```txt

Add a line to the request header

🟩 param  string  line to add, eg "Connection: keep-alive"

```

[line: 681](https://git-repo.iml.unibe.ch/iml-open-source/bash-rest-api-client/-/blob/master/rest-api-client.sh#L681)

### http.dump()

```txt

Dump information about request and response

no params

```

[line: 576](https://git-repo.iml.unibe.ch/iml-open-source/bash-rest-api-client/-/blob/master/rest-api-client.sh#L576)

### http.flushCache()

```txt

Flush the cache

no params

```

[line: 841](https://git-repo.iml.unibe.ch/iml-open-source/bash-rest-api-client/-/blob/master/rest-api-client.sh#L841)

### http.getRequestAge()

```txt

Get age of the response in sec.
It is especially useful after responseImport

no param

returns integer  age of the response in sec

```

[line: 423](https://git-repo.iml.unibe.ch/iml-open-source/bash-rest-api-client/-/blob/master/rest-api-client.sh#L423)

### http.getRequestTs()

```txt

Get timestamp of the response as a Unix timestamp.

no param

returns string  the timestamp of the response

```

[line: 409](https://git-repo.iml.unibe.ch/iml-open-source/bash-rest-api-client/-/blob/master/rest-api-client.sh#L409)

### http.getResponse()

```txt

Get response body

no param

returns string  the response body

```

[line: 442](https://git-repo.iml.unibe.ch/iml-open-source/bash-rest-api-client/-/blob/master/rest-api-client.sh#L442)

### http.getResponseData()

```txt

Get curl data of this request with status, transferred bytes, speed, ...

no param

returns string  the response data

```

[line: 455](https://git-repo.iml.unibe.ch/iml-open-source/bash-rest-api-client/-/blob/master/rest-api-client.sh#L455)

### http.getResponseHeader()

```txt

Get response header

no param

returns string  the response header

```

[line: 468](https://git-repo.iml.unibe.ch/iml-open-source/bash-rest-api-client/-/blob/master/rest-api-client.sh#L468)

### http.getResponseRaw()

```txt

Get raw response (not available after import)

no params

no param

```

[line: 481](https://git-repo.iml.unibe.ch/iml-open-source/bash-rest-api-client/-/blob/master/rest-api-client.sh#L481)

### http.getStatus()

```txt

Get Http status as string OK|Redirect|Error

no params

```

[line: 492](https://git-repo.iml.unibe.ch/iml-open-source/bash-rest-api-client/-/blob/master/rest-api-client.sh#L492)

### http.getStatuscode()

```txt

Get Http status code of the request as 3 digit number

no params

```

[line: 505](https://git-repo.iml.unibe.ch/iml-open-source/bash-rest-api-client/-/blob/master/rest-api-client.sh#L505)

### http.help()

```txt

show a help text

no params

```

[line: 852](https://git-repo.iml.unibe.ch/iml-open-source/bash-rest-api-client/-/blob/master/rest-api-client.sh#L852)

### http.init()

```txt

Initialize the client

Initialize the client for a new request. Call this before any other
function. It will reset all variables.

```

[line: 116](https://git-repo.iml.unibe.ch/iml-open-source/bash-rest-api-client/-/blob/master/rest-api-client.sh#L116)

### http.isClientError()

```txt

Was the repsonse a client error (4xx)

no params

```

[line: 554](https://git-repo.iml.unibe.ch/iml-open-source/bash-rest-api-client/-/blob/master/rest-api-client.sh#L554)

### http.isError()

```txt

Was the repsonse a client error (4xx or 5xx)

no params

```

[line: 543](https://git-repo.iml.unibe.ch/iml-open-source/bash-rest-api-client/-/blob/master/rest-api-client.sh#L543)

### http.isOk()

```txt

Check: was response a 2xx status code?
output is a statuscode if it matches ... or empty
Additionally you can verify the return code

$? -eq 0 means YES
$? -ne 0 means NO

no params

```

[line: 521](https://git-repo.iml.unibe.ch/iml-open-source/bash-rest-api-client/-/blob/master/rest-api-client.sh#L521)

### http.isRedirect()

```txt

Was the repsonse a redirect?

no params

```

[line: 532](https://git-repo.iml.unibe.ch/iml-open-source/bash-rest-api-client/-/blob/master/rest-api-client.sh#L532)

### http.isServerError()

```txt

Was the repsonse a client error (5xx)

no params

```

[line: 565](https://git-repo.iml.unibe.ch/iml-open-source/bash-rest-api-client/-/blob/master/rest-api-client.sh#L565)

### http.loadcfg()

```txt

Load a config file

This function is marked as deprecated.
It will be removed in the future.

🟩 param  string  config file name

Sourcing that file will set the following vars
- RestApiUser
- RestApiPassword
- RestApiBaseUrl
- RestApiDocs

The function will then set the "internal" vars
- http_req__auth
- http_req__fullurl
- http_req__docs

```

[line: 284](https://git-repo.iml.unibe.ch/iml-open-source/bash-rest-api-client/-/blob/master/rest-api-client.sh#L284)

### http.makeRequest()

```txt

Execute the request

🔹 param  string  optional: method; GET|POST|PUT|DELETE|...
🔹 param  string  optional: full url
🔹 param  string  optional: request body

description:

This function does the following:

1. Check if to use a cache
2. If not cached, make the request
3. If cached, use the cached result

```

[line: 168](https://git-repo.iml.unibe.ch/iml-open-source/bash-rest-api-client/-/blob/master/rest-api-client.sh#L168)

### http.quit()

```txt

Show error message with last return code and quit with this exitcode

This function is used to quit the script with a meaningful error message
and the exit code of the last command.

The message is printed to STDERR and contains the return code.
If a documentation URL is known, it is printed as a hint.

The exit code is the one of the last command.
To prevent the script from exiting when this function is called from a
sourced file, the exit is commented out.

no params

```

[line: 251](https://git-repo.iml.unibe.ch/iml-open-source/bash-rest-api-client/-/blob/master/rest-api-client.sh#L251)

### http.responseDelete()

```txt

Delete an exported file; this is especially useful if you use
AUTOFILE functionality

🟩 param  string  filename with stored response

```

[line: 652](https://git-repo.iml.unibe.ch/iml-open-source/bash-rest-api-client/-/blob/master/rest-api-client.sh#L652)

### http.responseExport()

```txt

Export response to a file

🔹 param  string  optional: custom filename

```

[line: 610](https://git-repo.iml.unibe.ch/iml-open-source/bash-rest-api-client/-/blob/master/rest-api-client.sh#L610)

### http.responseImport()

```txt

Import a former response from a file

🟩 param  string  filename with stored response

```

[line: 628](https://git-repo.iml.unibe.ch/iml-open-source/bash-rest-api-client/-/blob/master/rest-api-client.sh#L628)

### http.setAccept()

```txt

set Accept request header and override default

🟩 param  string  accept header value, eg text/html,application/xhtml+xml,application/xml;q=0.9,*/*;q=0.8

```

[line: 692](https://git-repo.iml.unibe.ch/iml-open-source/bash-rest-api-client/-/blob/master/rest-api-client.sh#L692)

### http.setAuth()

```txt

Set basic authentication
Without given parameter, authentication is removed

🔹 param  string  optional: USER:PASSWORD

```

[line: 708](https://git-repo.iml.unibe.ch/iml-open-source/bash-rest-api-client/-/blob/master/rest-api-client.sh#L708)

### http.setAuthorization()

```txt

Set authentication via Athorization header
Without given parameter, authorization is removed

🔹 param  string  optional: type, eg. Basic|Bearer|Negotiate
🔹 param  string  optional: token or encoded user + password

```

[line: 725](https://git-repo.iml.unibe.ch/iml-open-source/bash-rest-api-client/-/blob/master/rest-api-client.sh#L725)

### http.setBaseUrl()

```txt

Set a base url of an API
Remark: Then use http.setUrl to complet the url to request

🟩 param  string  url

```

[line: 752](https://git-repo.iml.unibe.ch/iml-open-source/bash-rest-api-client/-/blob/master/rest-api-client.sh#L752)

### http.setBody()

```txt

Set body to send for PUTs and POSTs

🟩 param  string  body

```

[line: 740](https://git-repo.iml.unibe.ch/iml-open-source/bash-rest-api-client/-/blob/master/rest-api-client.sh#L740)

### http.setCacheFile()

```txt

Set cache file

🟩 param  string  filename

```

[line: 830](https://git-repo.iml.unibe.ch/iml-open-source/bash-rest-api-client/-/blob/master/rest-api-client.sh#L830)

### http.setCacheTtl()

```txt

Set cache ttl in seconds

🟩 param  integer  ttl in seconds

```

[line: 819](https://git-repo.iml.unibe.ch/iml-open-source/bash-rest-api-client/-/blob/master/rest-api-client.sh#L819)

### http.setDebug()

```txt

Enable or disable debug mode

🟩 param  integer  0|1

```

[line: 764](https://git-repo.iml.unibe.ch/iml-open-source/bash-rest-api-client/-/blob/master/rest-api-client.sh#L764)

### http.setDocs()

[line: 768](https://git-repo.iml.unibe.ch/iml-open-source/bash-rest-api-client/-/blob/master/rest-api-client.sh#L768)

### http.setFullUrl()

```txt

Set a full url to request

🔹 param  string  optional: url

```

[line: 790](https://git-repo.iml.unibe.ch/iml-open-source/bash-rest-api-client/-/blob/master/rest-api-client.sh#L790)

### http.setMethod()

```txt

Set the method to use; GET|POST|PUT|DELETE|...

🟩 param  string  name of method

```

[line: 779](https://git-repo.iml.unibe.ch/iml-open-source/bash-rest-api-client/-/blob/master/rest-api-client.sh#L779)

### http.setUrl()

```txt

Complete the base url

🟩 param  string  url part behind base url

```

[line: 805](https://git-repo.iml.unibe.ch/iml-open-source/bash-rest-api-client/-/blob/master/rest-api-client.sh#L805)

- - -
Generated with [Bashdoc](https://github.com/axelhahn/bashdoc) v0.6
